import java.util.*;

        // Maintain a database of PCDetails.
        // A LinkedList is used to store each.
        // An ArrayList could be used instead.
class PCDatabase1 {
        // Add pc to the network with netid net and hostid host.
    public void addToNetwork(PCDetails pc,int net, int host){
        pc.setNetid(net);
        pc.setHostid(host);
        LinkedList network = getNetwork();
        network.add(pc);
    }

        // Move the pc with the given name to the given part of
        // the network (net) with the hostid host.
    public void movePC(String name,int net, int host){
        PCDetails pc = findPC(name);
        if(pc != null){
            pc.setNetid(net);
            pc.setHostid(host);
        }
    }

        // Change the hostid of the pc with the given name to be host.
        // It retains its current netid.
    public void movePC(String name,int host){
        PCDetails pc = findPC(name);
        if(pc != null){
            pc.setHostid(host);
        }
    }

        // Print the name, netid, hostid and owner of the given pc.
    public void printDetails(String name){
        PCDetails pc = findPC(name);
        if(pc != null){
            System.out.println(pc.toString());
        }
    }

        // Print details of all the pcs in the database, one per line.
    public void printAll(){
        LinkedList network = getNetwork();
        Iterator it = network.iterator();
        while(it.hasNext()){
            PCDetails pc = (PCDetails) it.next();
            System.out.println(pc.toString());
        }
    }

        // A method used by several of the other methods to find a PC
        // with a given name. Return null if the name is not found.
    private PCDetails findPC(String name){
        LinkedList network = getNetwork();
        Iterator it = network.iterator();
        while(it.hasNext()){
            PCDetails pc = (PCDetails) it.next();
            if(name.equals(pc.getName())){
                return pc;
            }
        }
        // No sign of it.
        return null;
    }

    private LinkedList getNetwork(){
        return network;
    }

    private final LinkedList network = new LinkedList();
}
