import java.util.*;

    // Maintain a collection of SuitedCard objects for a player.
    // Mostly a case of delegating to an underlying collection
    // and casting the result where required.
class Hand {
    public void add(SuitedCard c){
        if(c != null){
             getCards().add(c);
        }
    }

    public SuitedCard getNextCard(){
        return (SuitedCard) getCards().removeFirst();
    }

    public SuitedCard getCardInSuit(String suit){
        // Return a card with matching suit, if any.
        // Return null if there is none.
        Iterator cards = getCards().iterator();
        while(cards.hasNext()){
            SuitedCard c = (SuitedCard) cards.next();
            if(c.getSuit().equals(suit)){
                cards.remove();
                return c;
            }
        }
        return null;
    }

    public int numCards(){
        return getCards().size();
    }

    private LinkedList getCards(){
        return cards;
    }

    // Store the cards in a linked list, because we only need
    // access at either end.
    private final LinkedList cards = new LinkedList();
}

