        // A class to maintain a pair of temperature and
        // pressure variable.
class DualController {
        // A no-arg constructor for the class.
    public DualController(){
        // Ensure that the initial temperature is set to
        // a non-zero default value.
        // Make it clear what the number means by giving it a name.
        double defaultTemperature = 293.0;
        setTemperature(defaultTemperature);
        setPressure(4*getTemperature());
    }

        // Use the initial value provided in the argument, instead
        // of the default.
    public DualController(double initialTemp){
        setTemperature(initialTemp);
        setPressure(4*getTemperature());
    }

        // Temperature accessor.
    public double getTemperature(){
        return temperature;
    }

        // Temperature mutator.
    public void setTemperature(double setting){
        temperature = setting;
        // Register the change on the display.
        getDisplay().showTemperature(setting);
    }

    public double getPressure(){
        return pressure;
    }

    public void setPressure(double p){
        pressure = p;
        // Register the change on the display.
        getDisplay().showPressure(p);
    }

        // An accessor for the display object.
    private ValueDisplay getDisplay(){
        return display;
    }

    // The current temperature value.
    private double temperature;
    // The current pressure value.
    private double pressure;
    // A display for the temperature and pressure values.
    private ValueDisplay display = new ValueDisplay();
}
