        // Interactively prompt the user for 3 indices into an
        // array of integers. Divide the two operands, and store
        // the result at the destination.
        // Catch any resulting exceptions.
class ArrayExceptionMain1 {
    public static void main(String[] args){
        // Some random values.
        final int[] values = { 10, 0, 30, 40, 100, 5, 2 };
        final int numValues = values.length;
        final SimpleInput keyboard = new SimpleInput();

        // Allow 5 changes.
        final int numChanges = 5;
        for(int change = 0; change < numChanges; change++){
            try{
                // Show the values.
                for(int i = 0; i < numValues; i++){
                    System.out.print(values[i]+" ");
                }
                System.out.println();
                // Ask for the indices of the operand values.
                int operand1, operand2;
                System.out.println("Operands: ");
                operand1 = keyboard.nextInt();
                operand2 = keyboard.nextInt();

                int result = values[operand1]/values[operand2];
                System.out.println("The result is: "+result);

                // Ask for where it should be stored.
                System.out.println("Destination: ");
                int destination = keyboard.nextInt();
                values[destination] = result;
            }
            catch(ArrayIndexOutOfBoundsException e){
                System.err.println("Array index exception: "+
                                   e.getMessage());
            }
            catch(ArithmeticException e){
                System.err.println("Arithmetic exception: "+
                                   e.getMessage());
            }
        }
    }
}
