        // Create a single-space CarPark and test the
        // basic functionality of it.
class CarParkMain {
    public static void main(String[] args){
        try{
            // Create a single-location CarPark for basic testing.
            CarPark parkingLot = new CarPark(1);
            // Create two cars for testing.
            Car first = new Car("1"), second = new Car("2");

            reportStatus(parkingLot);
            int location = parkingLot.park(first);
            System.out.println("Car: "+first.getLicense()+
                               " parked at "+location);
            reportStatus(parkingLot);

            // Try to park the second.
            parkingLot.park(second);

            // Retrieve the first car.
            Car c = parkingLot.collect(location);
            if(c == first){
                System.out.println("Retrieved: "+first.getLicense());
            }
            reportStatus(parkingLot);

            // Try again to park the second.
            location = parkingLot.park(second);
            System.out.println("Car: "+second.getLicense()+
                               " parked at "+location);
        }
        catch(Exception e){
            System.err.println(e.getMessage());
        }
    }

        // Report the number of spaces in parkingLot,
        // and whether or not it is full.
    public static void reportStatus(CarPark parkingLot){
        System.out.println("Space(s): "+parkingLot.getSpaces());
        if(parkingLot.full()){
            System.out.println("The lot is full."); 
        }
        else{
            System.out.println("The lot is not full."); 
        }
    }
}
