import java.io.*;

        // Calculate the percentage of digits in the text file
        // passed as program argument.
class DigitPercentage {
    public static void main(String[] args) {
        if(args.length == 1){
            try{
                File fileDetails = new File(args[0]);
                FileReader reader = new FileReader(fileDetails);
                int ch = reader.read();
                long digitCount = 0;
                while(ch != -1){
                    if(Character.isDigit((char) ch)){
                        digitCount++;
                    }
                    ch = reader.read();
                }
                reader.close();

                final long fileSize = fileDetails.length();
                if(fileSize > 0){
                    System.out.println("The percentage of digits is: "+
                                       100.0*digitCount/fileSize);
                }
                else{
                    System.out.println("The file is empty.");
                }
            }
            catch(IOException e){
                System.err.println("File processing failure: "+
                                   e.getMessage());
            }
        }
        else{
            System.err.println("Usage: java DigitPercentage text-file");
        }
    }
}
