import java.io.*;
import java.util.Random;

        // Encode a message whose individual characters are
        // randomly scattered through the file: message.bin.
        // The length of the message is stored as an int at
        // offset 0 within the file. This is immediately followed
        // by the offset (from the start of the file) of the first
        // character of the message.  Thereafter, the next offset
        // follows each char in turn, up to the length of the message.
class MessageEncoder {
    public static void main(String[] args) throws IOException {
        final Random rand = new Random();
        final int LettersInAlphabet = 26;
        final String filename = "message.bin";
        final RandomAccessFile file =
                        new RandomAccessFile(filename,"rw");
        final int numChars = 8192;
        // Write random char values.
        for(int i = 0; i < numChars; i++){
            int offset = rand.nextInt(LettersInAlphabet);
            file.writeChar('a'+offset);
        }

        final String message = "seek and you will find";
        final int messageLength = message.length();

        // Write its length at the start of the file.
        file.seek(0L);
        file.writeInt(messageLength);

        final int bytesPerChar = 2, bytesPerInt = 4, bytesPerLong = 8;
        for(int i = 0; i < messageLength; i++){
            // Generate a random location for the next char.
            // Be cautious about making sure there will be room for
            // the char and the next offset before the end of the file.
            // Also make sure that it won't be right at the start of the
            // file where there is an int (4 bytes) and a long (8 bytes)
            // already located.
            long where = bytesPerInt+bytesPerLong+
                         rand.nextInt((int) (file.length()-
                                      (bytesPerChar+bytesPerLong)));
            System.out.println(message.charAt(i)+" @ "+where);
            file.writeLong(where);
            file.seek(where);
            file.writeChar(message.charAt(i));
        }
        file.close();
    }
}
