        // Maintain an array of Point objects, representing
        // the points of a closed shape.
class ClosedShape3 {
    // The minimum number of Points allowed.
    public static final int MIN_POINTS = 4;

    public ClosedShape3(Point[] points) throws
                        TooFewPoints, NonMatchingEndPoints {
        if(points == null){
            throw new TooFewPoints(
                    "Null array passed to constructor of ClosedShape.");
        }
        else if(points.length < MIN_POINTS){
            throw new TooFewPoints(
                    "ClosedShape requires at least "+MIN_POINTS+
                    " points.");
        }
        else{
            // Check that the start and end points coincide.
            Point first = points[0], last = points[points.length-1];
            if((first.getX() != last.getX()) ||
                        (first.getY() != last.getY())){
                throw new NonMatchingEndPoints(
                        "Unmatched start and end points in ClosedShape.");
            }
            else{
                this.points = points;
            }
        }
    }

    public Point[] getPoints(){
        return points;
    }

    private final Point[] points;
}
