import java.util.*;

        // Provide forward and backward iteration over an
        // array of objects. All methods of ListIterator have
        // been implemented, with the exception of add.
class ArrayIterator3 implements Iterator, ListIterator {
        // Retain a reference to the data to be iterated over.
    public ArrayIterator3(Object[] data){
        array = data;
    }

    public boolean hasNext(){
        return getLastIndex()+1 < getArray().length;
    }

    public Object next() throws NoSuchElementException {
        if(hasNext()){
            int index = getLastIndex()+1;
            // Update the value for next time.
            setLastIndex(index);
            return getArray()[index];
        }
        else{
            throw new NoSuchElementException();
        }
    }

    public boolean hasPrevious(){
        return getLastIndex() >= 0;
    }

    public Object previous() throws NoSuchElementException {
        if(hasPrevious()){
            int index = getLastIndex();
            setLastIndex(index-1);
            return getArray()[index];
        }
        else{
            throw new NoSuchElementException();
        }
    }

        // Remove an element by setting it to null.
    public void remove() throws IllegalStateException,
                                UnsupportedOperationException {
        int index = getLastIndex();
        if(index < 0){
            throw new IllegalStateException();
        }
        else{
            getArray()[index] = null;
        }
    }

    public void add(Object o) throws UnsupportedOperationException {
        throw new UnsupportedOperationException("add");
    }

        // NB: This method does not throw an IllegalStateException
        // if remove was called since the next next/previous call.
    public void set(Object o) throws IllegalStateException {
        int index = getLastIndex();
        if(index < 0){
            throw new IllegalStateException();
        }
        else{
            getArray()[index] = o;
        }
    }

    public int previousIndex(){
        return getLastIndex();
    }

    public int nextIndex(){
        return getLastIndex()+1;
    }

        // Accessors and mutators for the lastIndex and array attributes.
    private int getLastIndex(){
        return lastIndex;
    }

    private void setLastIndex(int n){
        lastIndex = n;
    }

    private Object[] getArray(){
        return array;
    }

    // The array of objects to be iterated over.
    private final Object[] array;
    // The index of the last element returned.
    private int lastIndex = -1;
}
