    /* A minder class for the (bug-ridden) Graph class.
     * Points are checked to ensure that they are within
     * the graph's area.
     * Lines may be drawn with their end points in either order.
     */
class GraphMinder {
        // Create a Graph and look after it.
    public GraphMinder(double minX, double maxX,double minY, double maxY){
        // Set the graph attribute.
        setGraph(new Graph(minX,maxX,minY,maxY));
    }

        // Add the given point into the graph.
    public void addPoint(double x, double y){
        Graph display = getGraph();
        if(pointOk(x,y)){
            display.drawPoint(x,y);
        }
    }

        // Add the given point into the graph.
    public void addLine(double x1, double y1, double x2, double y2){
        Graph display = getGraph();
        if(pointOk(x1,y1) && pointOk(x2,y2)){
            // Ensure that the end-points are `in order' because of
            // an error in the Graph class.
            if(x1 <= x2){
                display.drawLine(x1,y1,x2,y2);
            }
            else{
                display.drawLine(x2,y2,x1,y1);
            }
        }
    }

        // Return true if (x,y) lies within the graph.
    private boolean pointOk(double x,double y){
        Graph display = getGraph();
        if(x >= display.getMinX() && x <= display.getMaxX()){
            if(y >= display.getMinY() && y <= display.getMaxY()){
                return true;
            }
            else{
                return false;
            }
        }
        else{
            return false;
        }
    }

    private Graph getGraph(){
        return graph;
    }

    private void setGraph(Graph g){
        graph = g;
    }

    // The graph to be looked after. This must be initialised
    // by this class's constructor.
    private Graph graph;
}
