    // Read numbers from the user and print whether they are
    // divisible by 9 or not. This uses the `sum-of-digits == 9'
    // approach. Finish reading input when zero is entered by
    // the user.
class DivisibleByNine {
    public static void main(String[] args){
        SimpleInput keyboard = new SimpleInput();
        // The value to finish on.
        final int terminatingValue = 0;
        // Prompt for, and read, the first number.
        int num = promptForInput(keyboard,terminatingValue);

        while(num != terminatingValue){
            // Keep summing the digits of num until a single digit
            // remains.
            int digits = num;
            while(digits >= 10){
                digits = addDigits(digits);
            }
            if(digits == 9){
                System.out.println(num+" is divisible by 9");
            }
            else{
                System.out.println(num+" is not divisible by 9");
            }
            num = promptForInput(keyboard,terminatingValue);
        }
    }

        // Return the sum of the decimal digits in n.
        // For instance, addDigits(362023) would return 16.
    public static int addDigits(int n){
        // An accumulator for the digit sum.
        int digitSum = 0;
        while(n > 0){
            int digit = n % 10;
            digitSum += digit;
            // Remove the digit.
            n /= 10;
        }
        return digitSum;
    }

        // Ask the user for the next number.
    public static int promptForInput(SimpleInput keyboard,
                                     int terminatingValue){
        System.out.println("Type a number to be tested ("+
                           terminatingValue+" to finish).");
        return keyboard.nextInt();
    }
}
